<?

include "charconv.php";

function xml2array($elements_string)
{
    $xml_array = array();
    $elements_regex = '/<(\w+)\s*([^\/>]*)\s*(?:\/>|>(.*?)<(\/\s*\1\s*)>)/s';
    $attributes_regex = '/(\w+)=(?:"|\')([^"\']*)(:?"|\')/';
    preg_match_all ($elements_regex, $elements_string, $elements_array);
    foreach ( $elements_array[1] as $e_key => $e_value )
    {
        $xml_array[$e_key]["name"] = $e_value;
        if ( ($attributes_string = trim($elements_array[2][$e_key])) )
        {
            preg_match_all($attributes_regex, $attributes_string, $attributes_array);
            foreach ( $attributes_array[1] as $a_key => $a_value )
            {
                $xml_array[$a_key]["attributes"][$a_value] = $attributes_array[2][$a_key];
            }
        }
        if ( ($p = strpos($elements_array[3][$e_key], "<")) > 0 )
        {
            $xml_array[$e_key]["text"] = html_entity_decode(substr($elements_array[3][$e_key], 0, $p - 1),ENT_NOQUOTES,"utf-8");
        }
        if ( preg_match($elements_regex, $elements_array[3][$e_key]) )
        {       
            $xml_array[$e_key]["elements"] = xml2array($elements_array[3][$e_key]);
        }
        else if ( isset($elements_array[3][$e_key]) )
        {
            $xml_array[$e_key]["text"] = html_entity_decode($elements_array[3][$e_key],ENT_NOQUOTES,"utf-8");
        }
        $xml_array[$e_key]["closetag"] = $elements_array[4][$e_key];
    }
    return $xml_array;
}

function process_bankacctfrom($elements) {
  global $debug;
  $acctno = Array();

  foreach ($elements as $elem) {
   if ($debug) 
     echo "$elem[name] = $elem[text]\n";
   switch ($elem[name]) {
     case "BANKID": break;
     case "ACCTID": break;
   }
  }
}

function process_bankaccto($elements) {
  global $debug;

  $acctno = Array();

  foreach ($elements as $elem) {
   if ($debug)
     echo "$elem[name] = $elem[text]\n";
   switch ($elem[name]) {
     case "BANKID": break;
     case "ACCTID": break;
     case "ACCTKEY": break;
   }
  }
}


function process_tran($elements) {
  global $stmt_records;
  global $debug;

     $record = Array();
/*
     $record[amount] = $items[13] + 0;
     $record[date] = substr($items[2],0,2). substr($items[2],3,2). substr($stmt_year,2,2);
     $record[time] = $items[3];
     $record[fee] = $items[14] + $items[16];
     $record[partyname] = trim(win2ascii($items[5]));
     $record[comment] = trim(win2ascii(preg_replace("/\n/"," ",$items[4])));
     $record[comment2] = trim(win2ascii($items[9]));
*/

  $record[time]="00:00";
  $record[recno] = 0;

  $trantype="DEBIT";

  foreach ($elements as $elem) {
   switch ($elem[name]) {
     case "DTPOSTED": break;
     case "TRNTYPE": $trantype=$elem[text]; break;
     case "DTAVAIL": $record[date] = substr($elem[text],6,2). substr($elem[text],4,2). substr($elem[text],2,2); break;
     case "TRNAMT": $record[amount] = ($elem[text]+0)/100;break;
     case "TRNSPSYM": $record[ssymbol] = $elem[text];break;
     case "TRNVASYM": $record[vsymbol] = $elem[text];break;
     case "TRNCOSYM": $record[ksymbol] = $elem[text];break;
     case "NAME": $record[comment] = iconv("utf-8","ASCII//TRANSLIT",$elem[text]);break;
     case "BANKACCTO": process_bankaccto($elem[elements]);break;
     case "MEMO": $record[comment2] = iconv("utf-8","ASCII//TRANSLIT",$elem[text]); break;
     case "CURRENCY": break;
     default:
       if ($debug)
          echo "$elem[name] = $elem[text]<br>\n";
   }
  }

 $record[fee] = 0;

 if ($trantype == "DEBIT")
   $record[amount] *= -1;
 $stmt_records[count($stmt_records)] = $record;
   if ($debug) {
     echo "<font color=gren><pre>"; print_r($record);echo "</pre></font>"; }
}


function process_banktranlist($elements) {
  global $stmt_day0,$stmt_month0,$stmt_year0,$stmt_day1,$stmt_year1,$stmt_month1,$stmt_year;
  foreach ($elements as $elem) {
   switch ($elem[name]) {
     case "DTSTART": $stmt_day0=substr($elem[text],0,2); $stmt_month0=substr($elem[text],3,2) ;$stmt_year0=substr($elem[text],6,4); break;
     case "DTEND": $stmt_day1=substr($elem[text],0,2); $stmt_month1=substr($elem[text],3,2); $stmt_year=$stmt_year1=substr($elem[text],6,4); break;
     case "BALOPEN": break;
     case "BALCLOSE": break;
     case "STMTTRN": process_tran($elem[elements]);break;
   }
  }
}


$xml = xml2array($statementdata);

if ($xml[0][name] != "OFX")
  die("Statement error: Not OFX");

if ($xml[0][elements][0][name] != "STMTRS")
  die("Statement error: Not STMTRS");

$stmtrs = $xml[0][elements][0][elements];

if ($stmtrs[0][name] != "BANKACCTFROM")
  die("Statement error: Not BANKACCTFROM");


if ($stmtrs[1][name] != "BANKTRANLIST")
  die("Statement error: Not BANKTRANLIST");

process_bankacctfrom($stmtrs[0][elements]);
process_banktranlist($stmtrs[1][elements]);

$account_name = "RaiffeisenBank";

?>
